# File name: KookaSplash.py
# Copyright: The AustSTEM Foundation Limited
# Author: Tony Strasser
# Date created: 13 October 2018
# Date last modified: 4 December 2020
# Release Number: 1
# MicroPython Version: 1.12 for the Kookaberry V4-06
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation.
# To the fullest extent permitted by law, AustSTEM absolutely disclaims 
# all warranties, expressed or implied, including, but not limited to, 
# implied warranties of merchantability and fitness for any particular purpose. 
# AustSTEM gives no warranty that this software will be free of errors, 
# or that defects in the software will be corrected,  
# See the GNU General Public License for more details.
#
# Description
# Kookaberry splash screen using a bitmap
# Begin code
import kooka, framebuf, time, math
disp = kooka.display
# Create bitmaps splash screen
# Kookaberry text
bitmap = bytearray([0xFF, 0x03, 0x03, 0x03, 0xFF, 0x7F, 0x3F, 0x1F, 0x1F, 0x1F, 0x9F, 0xDF, 0x7F, 0x3F, 0x1F, 0x1F,
0x1F, 0x0F, 0x0F, 0x1F, 0x1F, 0x1F, 0x3F, 0x7F, 0xFF, 0xFF, 0xFF, 0x7F, 0x3F, 0x1F, 0x1F, 0x1F,
0x0F, 0x0F, 0x1F, 0x1F, 0x1F, 0x3F, 0x7F, 0xFF, 0xFF, 0x03, 0x03, 0x03, 0xFF, 0x7F, 0x3F, 0x1F,
0x1F, 0x1F, 0x9F, 0xDF, 0x7F, 0x3F, 0x1F, 0x1F, 0x1F, 0x0F, 0x0F, 0x1F, 0x1F, 0x1F, 0x3F, 0x7F,
0xFF, 0xFF, 0x03, 0x03, 0x03, 0x03, 0x1F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x1F, 0x1F, 0x3F, 0xFF,
0xFF, 0xFF, 0x7F, 0x3F, 0x1F, 0x1F, 0x1F, 0x0F, 0x0F, 0x1F, 0x1F, 0x1F, 0x3F, 0x7F, 0xFF, 0xFF,
0xFF, 0x3F, 0x3F, 0x1F, 0x1F, 0x1F, 0x0F, 0x0F, 0xFF, 0xFF, 0x3F, 0x3F, 0x1F, 0x1F, 0x1F, 0x1F,
0x0F, 0xFF, 0x1F, 0x1F, 0x1F, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1F, 0x1F, 0x1F,
0xFF, 0x00, 0x00, 0x00, 0xC1, 0x80, 0x00, 0x08, 0x1E, 0x3F, 0xFF, 0xC1, 0x00, 0x00, 0x08, 0x3E,
0x7F, 0x7F, 0x7F, 0x7F, 0x3E, 0x08, 0x00, 0x00, 0xC1, 0xFF, 0x80, 0x00, 0x00, 0x0C, 0x3E, 0x7F,
0x7F, 0x7F, 0x7F, 0x3E, 0x00, 0x00, 0x00, 0xC1, 0xFF, 0x00, 0x00, 0x00, 0xC1, 0x80, 0x00, 0x08,
0x1E, 0x3F, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x3E, 0x3F, 0x7F, 0x7F, 0x7F, 0x3E, 0x1C, 0x00, 0x00,
0x00, 0xFF, 0xE0, 0x80, 0x00, 0x00, 0x1E, 0x3F, 0x7F, 0x7F, 0x7F, 0x3F, 0x1C, 0x00, 0x00, 0x80,
0xFF, 0x80, 0x00, 0x00, 0x00, 0x20, 0x61, 0x61, 0x61, 0xE1, 0xE0, 0xE0, 0xE0, 0xE0, 0xE3, 0xFF,
0x00, 0x00, 0x00, 0xFC, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0xFC, 0xFE, 0xFF, 0xFF,
0xFF, 0xFF, 0xE0, 0x00, 0x00, 0x00, 0x1F, 0x3F, 0x7F, 0x7F, 0x7F, 0x3F, 0x1F, 0x00, 0x00, 0x00,
0xFF, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFC, 0xFC, 0xFC, 0xFC, 0xFD, 0xFF, 0xFE, 0xFC, 0xFC,
0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xFC, 0xFC, 0xFC,
0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFE, 0xFF, 0xFF, 0xFF, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFC,
0xFC, 0xFC, 0xFC, 0xFD, 0xFF, 0xFE, 0xFE, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC,
0xFC, 0xFF, 0xFF, 0xFF, 0xFE, 0xFE, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFE, 0xFF, 0xFF,
0xFF, 0xFF, 0xFF, 0xFE, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF,
0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xFE, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0x8C, 0x84, 0x80, 0xC0, 0x00])
for i in range(0, len(bitmap)-1): bitmap[i] = ~bitmap[i]    # bitwise invert
# Kookaburra outline
birdicon = bytearray([0xFF,0xFF,0xDF,0xAF,0xAF,0xB7,0x3B,0xFD,0xFD,0xFD,0xF9,0xF9,0x79,0xF9,0xF1,0x0F,
0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,

0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0xDF,0x3E,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
0xFF,0xFE,0xF9,0xC7,0x7F,0xFF,0xFF,0xFF,

0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xCF,0xCC,0xA3,0xFF,0xBF,0xBF,0xDF,0xBF,
0x7F,0xFF,0xFF,0xFF,0x7C,0x87,0x3F,0xFF,

0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
0xFF,0xF8,0xE7,0x1F,0x3C,0x07,0x3F,0xFF])
for i in range(0, len(birdicon)-1): birdicon[i] = ~birdicon[i]    # bitwise invert
# create the two framebuffers
splash = framebuf.FrameBuffer(bitmap, 128, 24, framebuf.MONO_VLSB)
icon = framebuf.FrameBuffer(birdicon, 24, 32, framebuf.MONO_VLSB)
# Display the frame buffers with the icon moving
y=18
x=100
x2 = 0
while not kooka.button_a.was_pressed():    # Press A to exit
    y2 = int( 18 * math.sin(math.pi / 32 * x2))
    x2 += 1
    if x2 > 32: x2 = 0
    disp.fill(0)
    disp.blit(splash, -1, 36)  # display the text
    disp.blit(icon, x,(y-y2),0)   # display the bird icon with black as transparent
    disp.show()
    x -= 1
    if x < -20: x=118
    timer = 1
    if x2 == 0 : timer = 1000
    time.sleep_ms(timer)
disp.fill(0)
disp.show()
